
package jess;
import java.io.Serializable;

/**
 <p>Use this subclass of Value when you want to create a Value that
 represents a <tt>Fact</tt>. </p>

 <p>In previous versions of Jess, fact-id's were more like integers; now
 they are really references to facts. As such, a fact-id must represent
 a valid {@link Fact} object.  Call
 {@link #javaObjectValue} to get the
 <tt>Fact</tt> object, and call
 {@link Fact#getFactId} to get the fact-id as an integer. This
 latter manipulation will now rarely, if ever, be necessary.
  </P>
  (C) 2006 Sandia National Laboratories<br>
 */

public class FactIDValue extends Value implements Serializable {
  /**
   * Create a FactIDValue
   * @param f The fact
   * @exception JessException If the type is invalid
   */

  public FactIDValue(Fact f) throws JessException
  {
    super(f);
  }
}

